/**
 * @(#)TextFileWriter.java 1.1 20/01/2005
 * Copyright 2005 usd.sie.dendai.ac.jp, All rights reserved.
 */
package jp.tdu.util;

import java.io.FileOutputStream;
import java.io.BufferedWriter;
import java.io.OutputStreamWriter;
import java.io.IOException;

/**
 * TextFileWriterNXSringCX^XAint^Adouble^邢TokensCX^X𕶎ɕϊA
 * t@CɏރNXłB
 * @version 1.0, 20/01/2005
 * @author miya@sie.dendai.ac.jp
 */
public final class TextFileWriter{
	private String filename = null;
	private FileOutputStream fout;
	private BufferedWriter bw;
	
	/**
	 * B̃RXgN^łB
	 * @param name ݐ̃t@C̖Ow肵܂B
	 */
	public TextFileWriter(String name){
		this.filename = name;
	}
	
	/**
	 * t@CJ܂BAt@C͐VK쐬ɂȂ܂B
	 * @return t@CJĂtrueAȊOłfalseԂ܂B
	 */
	public boolean open(){
		try{
			this.fout = new FileOutputStream(this.filename);
			this.bw = new BufferedWriter(new OutputStreamWriter(this.fout));
		}catch(IOException e){
			e.printStackTrace();
		}
		return this.bw != null ? true: false;
	}
	
	/**
	 * t@C܂B
	 */
	public void close(){
		try{
			this.bw.flush();
			this.fout.close();         
		}catch(IOException e){
			e.printStackTrace();
		}
	}
	
	/**
	 * t@C֏݂܂B
	 * @param string ޕB
	 */
	public void write(String string){
		try{
			this.bw.write(string);
		}catch(IOException e){
			e.printStackTrace();
		}
	}
	
	/**
	 * int^̒l𕶎ɕϊt@C֏݂܂B
	 * @param i int^̒lB
	 */
	public void write(int i){
	    this.write(new Integer(i).toString());
	}
	
	/**
	 * double^̒l𕶎ɕϊt@C֏݂܂B
	 * @param d double^̒lB
	 */
	public void write(double d){
	    this.write(new Double(d).toString());
	}
	
	/**
	 * s݂܂B
	 */
	public void newLine(){
		try{
			this.bw.newLine();
		}catch(IOException e){
			e.printStackTrace();
		}
	}
	
	/**
	 * TokensCX^X𕶎ɕϊt@C֏݂܂B
	 * @param tokens TokensCX^XB
	 */
	public void write(Tokens tokens){
		if(tokens.size() != 0){
			for(int i = 0; i < tokens.size(); i++){
				this.write((i != (tokens.size() - 1) ? tokens.getString(i) + " ": tokens.getString(i)));
			}
			this.newLine();
	    }
	}
}
